﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;

using TestProject.Models;

namespace TestProject.Controllers
{
    /// <summary>
    /// 기상 예보 컨트롤러
    /// </summary>
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 요약 배열
        /// </summary>
        private static readonly string[] _symmaryArray = new[]
        {
            "Freezing",
            "Bracing",
            "Chilly",
            "Cool",
            "Mild",
            "Warm",
            "Balmy",
            "Hot",
            "Sweltering",
            "Scorching"
        };

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 로그 기록기
        /// </summary>
        private readonly ILogger<WeatherForecastController> logger;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - WeatherForecastController(logger)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="logger">로그 기록기</param>
        public WeatherForecastController(ILogger<WeatherForecastController> logger)
        {
            this.logger = logger;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 열거 가능형 목록 구하기 - Get()

        /// <summary>
        /// 열거 가능형 목록 구하기
        /// </summary>
        /// <returns>열거 가능형 목록</returns>
        [HttpGet]
        public IEnumerable<WeatherForecastModel> Get()
        {
            Random random = new Random();

            return Enumerable.Range(1, 5).Select
            (
                index => new WeatherForecastModel
                {
                    Date         = DateTime.Now.AddDays(index),
                    TemperatureC = random.Next(-20, 55),
                    Summary      = _symmaryArray[random.Next(_symmaryArray.Length)]
                }
            )
            .ToArray();
        }

        #endregion
    }
}